Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
Botan::Device_EntropySource Class Referencefinal

`#include <dev_random.h>`

Inheritance diagram for Botan::Device_EntropySource:

## Public Member Functions
| Device_EntropySource (const std::vector< std::string > &fsnames)
std::string | name () const override
size_t | poll (RandomNumberGenerator &rng) override
| ~Device_EntropySource ()

## Static Public Member Functions
static std::unique_ptr< Entropy_Source > | create (const std::string &type)

## Detailed Description

Entropy source reading from kernel devices like /dev/random

Definition at line 20 of file dev_random.h.

## Constructor & Destructor Documentation

Botan::Device_EntropySource::Device_EntropySource | ( | const std::vector< std::string > & | fsnames | ) |

Device_EntropySource constructor Open a file descriptor to each (available) device in fsnames

Definition at line 23 of file dev_random.cpp.

References Botan::PKCS11::flags(), Botan::CT::max(), O_NOCTTY, O_NONBLOCK, and Botan::ASN1::to_string().

24 {
25 #ifndef O_NONBLOCK
26 #define O_NONBLOCK 0
27 #endif
28
29 #ifndef O_NOCTTY
30 #define O_NOCTTY 0
31 #endif
32
33 const int flags = O_RDONLY | O_NONBLOCK | O_NOCTTY;
34
35 m_max_fd = 0;
36
37 for(auto fsname : fsnames)
38 {
39 int fd = ::open(fsname.c_str(), flags);
40
41 if(fd < 0)
42 {
43 /*
44 ENOENT or EACCES is normal as some of the named devices may not exist
45 on this system. But any other errno value probably indicates
46 either a bug in the application or file descriptor exhaustion.
47 */
48 if(errno != ENOENT && errno != EACCES)
49 throw Exception("Opening OS RNG device failed with errno " +
50 std::to_string(errno));
51 }
52 else
53 {
54 if(fd > FD_SETSIZE)
55 {
56 ::close(fd);
57 throw Exception("Open of OS RNG succeeded but fd is too large for fd_set");
58 }
59
60 m_dev_fds.push_back(fd);
61 m_max_fd = std::max(m_max_fd, fd);
62 }
63 }
64 }
Botan::PKCS11::flags
Flags flags(Flag flags)
Definition: p11.h:858
O_NONBLOCK
#define O_NONBLOCK
Botan::ASN1::to_string
std::string to_string(const BER_Object &obj)
Definition: asn1_obj.cpp:47
O_NOCTTY
#define O_NOCTTY
Botan::CT::max
T max(T a, T b)
Definition: ct_utils.h:173

Botan::Device_EntropySource::~Device_EntropySource | ( |  | ) |

Device_EntropySource destructor: close all open devices

Definition at line 69 of file dev_random.cpp.

70 {
71 for(int fd : m_dev_fds)
72 {
73 // ignoring return value here, can't throw in destructor anyway
74 ::close(fd);
75 }
76 }

## Member Function Documentation

std::unique_ptr< Entropy_Source > Botan::Entropy_Source::create | ( | const std::string & | type | ) |
| static inherited

Return a new entropy source of a particular type, or null Each entropy source may require substantial resources (eg, a file handle or socket instance), so try to share them among multiple RNGs, or just use the preconfigured global list accessed by Entropy_Sources::global_sources()

Definition at line 45 of file entropy_srcs.cpp.

Referenced by Botan::Entropy_Sources::Entropy_Sources().

46 {
47 if(name == "rdrand")
48 {
49 #if defined(BOTAN_HAS_ENTROPY_SRC_RDRAND)
50 return std::unique_ptr<Entropy_Source>(new Intel_Rdrand);
51 #endif
52 }
53
54 if(name == "rdseed")
55 {
56 #if defined(BOTAN_HAS_ENTROPY_SRC_RDSEED)
57 return std::unique_ptr<Entropy_Source>(new Intel_Rdseed);
58 #endif
59 }
60
61 if(name == "darwin_secrandom")
62 {
63 #if defined(BOTAN_HAS_ENTROPY_SRC_DARWIN_SECRANDOM)
64 return std::unique_ptr<Entropy_Source>(new Darwin_SecRandom);
65 #endif
66 }
67
68 if(name == "getentropy")
69 {
70 #if defined(BOTAN_HAS_ENTROPY_SRC_GETENTROPY)
71 return std::unique_ptr<Entropy_Source>(new Getentropy);
72 #endif
73 }
74
75 if(name == "dev_random")
76 {
77 #if defined(BOTAN_HAS_ENTROPY_SRC_DEV_RANDOM)
78 return std::unique_ptr<Entropy_Source>(new Device_EntropySource(BOTAN_SYSTEM_RNG_POLL_DEVICES));
79 #endif
80 }
81
82 if(name == "win32_cryptoapi")
83 {
84 #if defined(BOTAN_HAS_ENTROPY_SRC_CAPI)
85 return std::unique_ptr<Entropy_Source>(new Win32_CAPI_EntropySource("RSA_FULL"));
86 #endif
87 }
88
89 if(name == "proc_walk")
90 {
91 #if defined(BOTAN_HAS_ENTROPY_SRC_PROC_WALKER)
92 const std::string root_dir = BOTAN_ENTROPY_PROC_FS_PATH;
93 if(!root_dir.empty())
94 return std::unique_ptr<Entropy_Source>(new ProcWalking_EntropySource(root_dir));
95 #endif
96 }
97
98 if(name == "system_stats")
99 {
100 #if defined(BOTAN_HAS_ENTROPY_SRC_WIN32)
101 return std::unique_ptr<Entropy_Source>(new Win32_EntropySource);
102 #endif
103 }
104
105 return std::unique_ptr<Entropy_Source>();
106 }
Botan::Entropy_Source::name
virtual std::string name() const =0

std::string Botan::Device_EntropySource::name | ( |  | ) | const
| inline override virtual

Returns
  name identifying this entropy source

Implements Botan::Entropy_Source.

Definition at line 23 of file dev_random.h.

23 { return "dev_random"; }

size_t Botan::Device_EntropySource::poll | ( | RandomNumberGenerator & | rng | ) |
| override virtual

Gather entropy from a RNG device

Implements Botan::Entropy_Source.

Definition at line 81 of file dev_random.cpp.

References Botan::RandomNumberGenerator::add_entropy(), and Botan::CT::select().

82 {
83 size_t bits = 0;
84
85 if(m_dev_fds.size() > 0)
86 {
87 fd_set read_set;
88 FD_ZERO(&read_set);
89
90 for(int dev_fd : m_dev_fds)
91 {
92 FD_SET(dev_fd, &read_set);
93 }
94
95 secure_vector<uint8_t> io_buf(BOTAN_SYSTEM_RNG_POLL_REQUEST);
96
97 struct ::timeval timeout;
98 timeout.tv_sec = (BOTAN_SYSTEM_RNG_POLL_TIMEOUT_MS / 1000);
99 timeout.tv_usec = (BOTAN_SYSTEM_RNG_POLL_TIMEOUT_MS % 1000) * 1000;
100
101 if(::select(m_max_fd + 1, &read_set, nullptr, nullptr, &timeout) > 0)
102 {
103 for(int dev_fd : m_dev_fds)
104 {
105 if(FD_ISSET(dev_fd, &read_set))
106 {
107 const ssize_t got = ::read(dev_fd, io_buf.data(), io_buf.size());
108
109 if(got > 0)
110 {
111 rng.add_entropy(io_buf.data(), static_cast<size_t>(got));
112 bits += got * 8;
113 }
114 }
115 }
116 }
117 }
118
119 return bits;
120 }
Botan::CT::select
T select(T mask, T from0, T from1)
Definition: ct_utils.h:98

The documentation for this class was generated from the following files:

- src/lib/entropy/dev_random/dev_random.h
- src/lib/entropy/dev_random/dev_random.cpp